<template>
  <div class="card" :class="widgetClasses">
    <div class="card-header border-0 pt-5">
      <h3 class="card-title align-items-start flex-column">
        <span class="card-label fw-bolder fs-3 mb-1">Data Roadmap</span>

        <span class="text-muted mt-1 fw-bold fs-7"
          >Total roadmap tersedia yaitu
          {{ data.dataRoadmap.data.length }} roadmap
        </span>
      </h3>

      <div
        class="card-toolbar"
        data-bs-toggle="tooltip"
        data-bs-placement="top"
        data-bs-trigger="hover"
        title="Click to add a user"
      >
        <a
          href="#"
          class="btn btn-sm btn-light-primary"
          data-bs-toggle="modal"
          data-bs-target="#kt_modal_invite_friends"
        >
          <span class="svg-icon svg-icon-3">
            <inline-svg src="media/icons/duotune/arrows/arr075.svg" />
          </span>
          Tambah Roadmap
        </a>
      </div>
    </div>
    <!--end::Header-->

    <!--begin::Body-->
    <div class="card-body py-3">
      <!--begin::Table container-->
      <div class="table-responsive">
        <!--begin::Table-->
        <table
          class="
            table table-row-dashed table-row-gray-300
            align-middle
            gs-0
            gy-4
          "
        >
          <!--begin::Table head-->
          <thead>
            <tr class="fw-bolder text-muted">
              <th class="w-25px">
                <div
                  class="
                    form-check form-check-sm form-check-custom form-check-solid
                  "
                >
                  <input
                    class="form-check-input"
                    type="checkbox"
                    @change="
                      checkedRows =
                        checkedRows.length === 6 ? [] : [0, 1, 2, 3, 4, 5]
                    "
                  />
                </div>
              </th>
              <th class="min-w-150px">Jurusan</th>
              <th class="min-w-140px">Deskripsi</th>
              <th class="min-w-140px">Singkatan</th>
              <th class="min-w-140px">Keterangan</th>
              <th class="min-w-100px text-end">Actions</th>
            </tr>
          </thead>
          <!--end::Table head-->

          <!--begin::Table body-->
          <tbody v-if="!data.dataRoadmap.isLoading">
            <template
              v-for="(item, index) in data.dataRoadmap.data"
              :key="index"
            >
              <tr>
                <td>
                  <div
                    class="
                      form-check
                      form-check-sm
                      form-check-custom
                      form-check-solid
                    "
                  >
                    <input
                      class="form-check-input widget-9-check"
                      type="checkbox"
                      :value="index"
                      v-model="checkedRows"
                    />
                  </div>
                </td>

                <td>
                  <!-- <div class="symbol symbol-45px me-5">
                      <img :src="item.image" alt="" />
                    </div> -->
                  <div class="d-flex justify-content-start flex-column">
                    <span class="text-dark fw-bolder fs-6">{{
                      item.title
                    }}</span>

                    <!-- <span
                        class="text-muted fw-bold text-muted d-block fs-7"
                        >{{ item.skills }}</span
                      > -->
                  </div>
                </td>

                <td>
                  <span
                    clspanss="text-dark fw-bolder text-hover-primary d-block fs-6 "
                    ><p style="text-align: justify">
                      {{ cutString(item.description) }}
                    </p></span
                  >
                  <!-- <span class="text-muted fw-bold text-muted d-block fs-7">{{
                    item.companySkills
                  }}</span> -->
                </td>

                <td>
                  <span
                    clspanss="text-dark fw-bolder text-hover-primary d-block fs-6"
                    >{{ item.majorAcronym }}</span
                  >
                </td>

                <td>
                  <span
                    clspanss="text-dark fw-bolder text-hover-primary d-block fs-6"
                    >{{ cutString(item.note) }}</span
                  >
                </td>

                <td class="text-end">
                  <a
                    data-bs-toggle="modal"
                    :data-bs-target="'#exampleModal' + item._id"
                    class="
                      btn btn-icon btn-bg-light btn-active-color-primary btn-sm
                      me-1
                    "
                    @click="findData(item._id)"
                  >
                    <span class="svg-icon svg-icon-3">
                      <inline-svg src="media/icons/duotune/art/art005.svg" />
                    </span>
                  </a>

                  <a
                    href="#"
                    class="
                      btn btn-icon btn-bg-light btn-active-color-primary btn-sm
                    "
                  >
                    <span class="svg-icon svg-icon-3">
                      <inline-svg
                        src="media/icons/duotune/general/gen027.svg"
                      />
                    </span>
                  </a>
                </td>
              </tr>
              <div
                class="modal fade"
                :id="'exampleModal' + item._id"
                tabindex="-1"
                aria-labelledby="exampleModalLabel"
                aria-hidden="true"
              >
                <div class="modal-dialog modal-lg">
                  <div class="modal-content">
                    <div class="modal-header">
                      <h5 class="modal-title" id="exampleModalLabel">
                        Edit Roadmap {{ item.title }}
                      </h5>
                      <button
                        type="button"
                        class="btn-close"
                        data-bs-dismiss="modal"
                        aria-label="Close"
                      ></button>
                    </div>
                    <div class="modal-body">
                      <form>
                        <div class="mb-3">
                          <label for="recipient-name" class="col-form-label"
                            >Title:</label
                          >
                          <input
                            v-model="title"
                            type="text"
                            class="form-control"
                            id="recipient-name"
                          />
                        </div>
                        <div class="mb-3">
                          <label for="message-text" class="col-form-label"
                            >Deskripsi:</label
                          >
                          <textarea
                            v-model="deskripsi"
                            rows="15"
                            class="form-control"
                            id="message-text"
                          ></textarea>
                        </div>
                        <div class="mb-3">
                          <label for="recipient-name" class="col-form-label"
                            >Singkatan:</label
                          >
                          <input
                            type="text"
                            v-model="singkatan"
                            class="form-control"
                            id="akronim"
                          />
                        </div>
                        <div class="mb-3">
                          <label for="recipient-name" class="col-form-label"
                            >Notes:</label
                          >
                          <input
                            type="text"
                            v-model="note"
                            class="form-control"
                            id="akronim"
                          />
                        </div>
                      </form>
                    </div>
                    <div class="modal-footer">
                      <button
                        type="button"
                        class="btn btn-primary"
                        @click.prevent="submitEdit"
                        data-bs-dismiss="modal"
                      >
                        Submit
                      </button>
                    </div>
                  </div>
                </div>
              </div>
            </template>
          </tbody>
        </table>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, ref, reactive } from "vue";
import axios from "axios";
import useNotyf from "@/store/composable/useNotyf";
import { number, string } from "yup/lib/locale";

export default defineComponent({
  name: "kt-widget-9",
  components: {},
  props: {
    widgetClasses: String,
  },
  setup() {
    let api = reactive(process.env.VUE_APP_API_URL);
    const checkedRows = ref([]);
    const notif = useNotyf();
    const idGlobal = ref();
    const title = ref();
    const note = ref();
    const deskripsi = ref();
    const singkatan = ref();

    interface StateInterface {
      dataRoadmap: {
        data: Record<string, unknown>[];
        isLoading: boolean;
      };
    }

    const data = reactive<StateInterface>({
      dataRoadmap: {
        data: [],
        isLoading: true,
      },
    });

    const cutString = (string, length = 50) => {
      if (string.length <= length) {
        return string;
      }
      return `${string.substring(0, length)}...`;
    };

    const getRoadmap = async () => {
      try {
        data.dataRoadmap.isLoading = true;

        const result = await axios.get(`${api}/roadmap`);

        data.dataRoadmap.data = [];
        if (result.status === 200) {
          result.data.forEach((e) => {
            data.dataRoadmap.data.push(e);
          });
          data.dataRoadmap.isLoading = false;
        }
      } catch (error: any) {
        notif.error(error);
      }
    };

    const findData = (id: number) => {
      const result = data.dataRoadmap.data.find((x) => x._id == id);
      idGlobal.value = result?._id;
      title.value = result?.title;
      deskripsi.value = result?.description;
      singkatan.value = result?.majorAcronym;
      note.value = result?.note;
    };

    getRoadmap();

    const submitEdit = async () => {
      try {
        const response = await axios.put(`${api}/roadmap/${idGlobal.value}`, {
          title: title.value,
          description: deskripsi.value,
          majorAcronym: singkatan.value,
          note: note.value,
        });

        if (response.status == 200) {
          notif.success("Roadmap berhasil diubah");
          getRoadmap();
        }
      } catch (error) {
        console.log(error);
      }
    };

    return {
      data,
      title,
      findData,
      submitEdit,
      cutString,
      deskripsi,
      singkatan,
      note,
      checkedRows,
    };
  },
});
</script>
